'use strict';

var _through = require('through2');

var _through2 = _interopRequireDefault(_through);

var _ngConventions = require('ng-conventions');

var _ngConventions2 = _interopRequireDefault(_ngConventions);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _gulpUtil = require('gulp-util');

var _gulpUtil2 = _interopRequireDefault(_gulpUtil);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = function () {
    return _through2.default.obj(function (file, enc, cb) {
        if (file.isNull()) {
            return cb(null, file);
        }

        if (file.isStream()) {
            return cb(new _gulpUtil2.default.PluginError('gulp-ng-conventions', 'Streaming not supported'));
        }

        try {
            file.contents = new Buffer((0, _ngConventions2.default)(_path2.default.relative(file.base, file.path), String(file.contents), function (f) {
                return _fs2.default.existsSync(_path2.default.join(file.base, f));
            }));
            return cb(null, file);
        } catch (e) {
            console.error('ng-conventions failed for file ' + file.path, e);
            return cb(e);
        }
    });
};